//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%39A3EEC3003D.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%39A3EEC3003D.cm

//## begin module%39A3EEC3003D.cp preserve=no
//## end module%39A3EEC3003D.cp

//## Module: EinsteinResponse%39A3EEC3003D; Package specification
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/Detector/EinsteinResponse.h

#ifndef EINSTEINRESPONSE_H
#define EINSTEINRESPONSE_H 1

//## begin module%39A3EEC3003D.additionalIncludes preserve=no
//## end module%39A3EEC3003D.additionalIncludes

//## begin module%39A3EEC3003D.includes preserve=yes
//## end module%39A3EEC3003D.includes

// RealResponse
#include <XSModel/Data/Detector/RealResponse.h>
// EinsteinIO
#include <XSModel/DataFactory/EinsteinIO.h>
//## begin module%39A3EEC3003D.declarations preserve=no
//## end module%39A3EEC3003D.declarations

//## begin module%39A3EEC3003D.additionalDeclarations preserve=yes
//## end module%39A3EEC3003D.additionalDeclarations


//## begin EinsteinResponse%3641DCBB02DD.preface preserve=yes
//## end EinsteinResponse%3641DCBB02DD.preface

//## Class: EinsteinResponse%3641DCBB02DD
//## Category: XSModel::Data::Detector%36349D570394
//## Subsystem: XSModel::Data::Detector%367691B76668
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3A40E0FC008D;SpectralData { -> }

class EinsteinResponse : public RealResponse, //## Inherits: <unnamed>%376A617AE310
                         	public EinsteinIO  //## Inherits: <unnamed>%39A3ED4A0291
{
  //## begin EinsteinResponse%3641DCBB02DD.initialDeclarations preserve=yes
  //## end EinsteinResponse%3641DCBB02DD.initialDeclarations

  public:
    //## Constructors (generated)
      EinsteinResponse();

      EinsteinResponse(const EinsteinResponse &right);

    //## Destructor (generated)
      virtual ~EinsteinResponse();


    //## Other Operations (specified)
      //## Operation: clone%380DF4C2A338
      virtual EinsteinResponse* clone () const;

      //## Operation: fileFormat%39A3ED9502D0
      //	type() returns true if the input filename is of the
      //	format corresponding to the class.
      bool fileFormat (const string& fileName, XspecDataIO::DataType type = XspecDataIO::SpectrumType);

      //## Operation: read%3A228ED10113
      size_t read (const string& fileName, bool readFlag = true);

      //## Operation: closeSourceFiles%3A39410F02E4
      void closeSourceFiles ();

    // Additional Public Declarations
      //## begin EinsteinResponse%3641DCBB02DD.public preserve=yes
      //## end EinsteinResponse%3641DCBB02DD.public

  protected:

    //## Other Operations (specified)
      //## Operation: groupQuality%39FEF1B5002A
      virtual void groupQuality ();

      //## Operation: setArrays%3A01E4140060
      virtual void setArrays ();

      //## Operation: setDescription%3A01E419023C
      virtual void setDescription (size_t spectrumNumber = 1, size_t groupNumber = 1);

      //## Operation: Swap%3A95889402B1
      //## Exceptions: ()
      virtual void Swap (RealResponse& right) throw ();

    // Additional Protected Declarations
      //## begin EinsteinResponse%3641DCBB02DD.protected preserve=yes
      //## end EinsteinResponse%3641DCBB02DD.protected

  private:
    //## Assignment Operation (generated)
      EinsteinResponse & operator=(const EinsteinResponse &right);


    //## Other Operations (specified)
      //## Operation: copy%3A955CDD00FE
      virtual void copy (const RealResponse& right);

    // Additional Private Declarations
      //## begin EinsteinResponse%3641DCBB02DD.private preserve=yes
      //## end EinsteinResponse%3641DCBB02DD.private

  private: //## implementation
    // Additional Implementation Declarations
      //## begin EinsteinResponse%3641DCBB02DD.implementation preserve=yes
      //## end EinsteinResponse%3641DCBB02DD.implementation

};

//## begin EinsteinResponse%3641DCBB02DD.postscript preserve=yes
//## end EinsteinResponse%3641DCBB02DD.postscript

// Class EinsteinResponse 

//## begin module%39A3EEC3003D.epilog preserve=yes
//## end module%39A3EEC3003D.epilog


#endif
